library PasJniTest;

{$mode objfpc}{$H+}

uses
  //Classes
  jni;

//von fpc-wiki-Using_Pascal_Libraries_with_Java
function JStringtoString(PEnv: PJNIEnv; Obj: JObject; JavaStr: JString) : String;
begin
result  := (PEnv^^).GetStringUTFChars(PEnv, JavaStr, nil);
 (PEnv^^).ReleaseStringUTFChars(PEnv, JavaStr, nil); // release memory to avoid memory leak
end;

function StringToJString(PEnv: PJNIEnv; Obj: JObject; const AString: PChar): JString;
begin
  Result := (PEnv^^).NewStringUTF(PEnv, PChar(AString));
end;


procedure Java_PasJniTest_printHelloInPascal(PEnv: PJNIEnv; Obj: JObject; AMessage: JString); cdecl;
var s:string;
begin
  s:=JStringtoString(PEnv, Obj, AMessage);
  WriteLn('Message from JVM:'+s);
end;

function Java_PasJniTest_printHelloInJava(PEnv: PJNIEnv; Obj: JObject): JString; cdecl;
begin
  Result:=StringToJString(PEnv, Obj, 'Hello from FreePascal');
end;

exports
Java_PasJniTest_printHelloInPascal,
 Java_PasJniTest_printHelloInJava;
//printHelloInPascal name 'Java_PasJniTest_printHelloInPascal',
//printHelloInJava name 'Java_PasJniTest_printHelloInJava' ;


end.

